%define snapshot 0

%ifarch %{arm} aarch64 %{ix86}
%define build_docs 0
%else
%define build_docs 0
%endif

%define qtmajor 5
%define qtminor 15
%define qtsubminor 6

%define rel 1
%define pre rc

%define qtversion %{qtmajor}.%{qtminor}.%{qtsubminor}

%define libqtquickcontrols2 %mklibname qt5quickcontrols2_ %qtmajor
%define libqtquickcontrols2_d %mklibname qt5quickcontrols2 -d

%define libqtquicktemplates2 %mklibname qt5quicktemplates2_ %qtmajor
%define libqtquicktemplates2_d %mklibname qt5quicktemplates2 -d

%if %snapshot
%define qttarballdir qtquickcontrols2-everywhere-src-%{qtversion}-%pre
%else
%define qttarballdir qtquickcontrols2-everywhere-opensource-src-%{qtversion}
%endif

Name: qtquickcontrols25
Version: %{qtversion}
Release: %mkrel %{rel}
Summary: Qt5 - module with set of QtQuick controls
Group: Development/Libraries
License: LGPLv2 with exceptions or GPLv3 with exceptions and GFDL
URL:     https://www.qt.io/
Source0: https://download.qt.io/official_releases/qt/%{qtmajor}.%{qtminor}/%{version}/submodules/%{qttarballdir}.tar.xz

# Upstream patchs
# https://community.kde.org/Qt5PatchCollection
Patch0001:	0001-Unset-mouseGrabberPopup-if-it-s-removed-from-childre.patch
Patch0002:      0002-Ensure-we-don-t-crash-when-changing-sizes-after-clea.patch
Patch0003:      0003-QQuickAction-don-t-grab-the-same-shortcut-multiple-t.patch
Patch0004:      0004-QQuickAbstractButton-fix-crash-on-destruction.patch
Patch0005:      0005-Fix-scroll-bars-not-showing-up-when-binding-to-stand.patch

BuildRequires: qtbase5-devel >= %version
BuildRequires: pkgconfig(Qt5Quick) >= %version

Provides:      qtquickcontrols2 = %version-%release
Provides:      qt5-qtquickcontrols2 = %version-%release

#Branch Patchs

#Trunk Patchs

#Patch from Mageia

%description
The Qt Quick Controls module provides a set of controls that can be used to
build complete interfaces in Qt Quick.

%files
%_qt5_qml/Qt/labs/calendar
%_qt5_qml/QtQuick/Controls.2
%_qt5_qml/Qt/labs/platform
%_qt5_qml/QtQuick/Templates.2
%_qt5_examplesdir/quickcontrols2

#------------------------------------------------------------------------------

%if %{build_docs}
%package doc
Summary: QtQuickControls2%{qtmajor} APIs and tools docs
Group:   Documentation
BuildArch: noarch
BuildRequires: qttools5
# This one is required to build QCH-format documentation
# for APIs and tools in this package set
BuildRequires: qttools5-assistant
Recommends: qttools5-assistant

%description doc
Documentation for APIs and tools in QtQuickControls25 package for use with
Qt Assistant.

%files doc
%{_qt5_docdir}/qtlabscalendar.qch
%{_qt5_docdir}/qtlabscalendar/
%{_qt5_docdir}/qtlabsplatform.qch
%{_qt5_docdir}/qtlabsplatform/
%{_qt5_docdir}/qtquickcontrols.qch
%{_qt5_docdir}/qtquickcontrols/
%endif

#------------------------------------------------------------------------------

%package -n %{libqtquickcontrols2}
Summary: Qt%{qtmajor} QuickControls2 Library
Group: System/Libraries

Provides:  %{_lib}qt5labstemplates5 = %{version}-%{release}
Obsoletes: %{_lib}qt5labstemplates5 < 5.13.0-4

%description -n %{libqtquickcontrols2}
Qt%{qtmajor} QuickControls2 Component Library.

%files -n %{libqtquickcontrols2}
%{_qt5_libdir}/libQt5QuickControls2.so.%{qtmajor}*

#------------------------------------------------------------------------------

%package -n %{libqtquicktemplates2}
Summary: Qt%{qtmajor} QuickTemplates2 Library
Group: System/Libraries

Provides:  %{_lib}qt5quicktemplates5 = %{version}-%{release}
Obsoletes: %{_lib}qt5quicktemplates5 < 5.13.0-4

%description -n %{libqtquicktemplates2}
Qt%{qtmajor} QuickTemplates2 Component Library.

%files -n %{libqtquicktemplates2}
%{_qt5_libdir}/libQt5QuickTemplates2.so.%{qtmajor}*

#------------------------------------------------------------------------------

%package -n %{libqtquickcontrols2_d}
Summary: Devel files needed to build apps based on QtQuickControls2
Group:    Development/Libraries
Requires: %{libqtquickcontrols2} = %version
Provides: libqtquickcontrols25-devel = %version
Provides: libqt5quickcontrols2-devel = %version
Provides: qtquickcontrols25-devel = %version
Provides: qt5quickcontrols2-devel = %version
Provides: qt5-qtquickcontrols2-devel = %version

Provides:  %{_lib}qt5labstemplates-devel = %version-%release
Obsoletes: %{_lib}qt5labstemplates-devel < 5.13.0-4

%description -n %{libqtquickcontrols2_d}
Devel files needed to build apps based on QtQuickControls2.

%files -n %{libqtquickcontrols2_d}
%{_qt5_archdatadir}/mkspecs/modules/qt_lib_quickcontrols2_private.pri
%{_qt5_archdatadir}/mkspecs/modules/qt_lib_quickcontrols2.pri
%{_qt5_libdir}/libQt5QuickControls2.so
%{_qt5_libdir}/libQt5QuickControls2.prl
%{_qt5_libdir}/cmake/Qt5QuickControls2/
%{_qt5_libdir}/pkgconfig/Qt5QuickControls2.pc
%{_qt5_includedir}/QtQuickControls2/

#------------------------------------------------------------------------------

%package -n %{libqtquicktemplates2_d}
Summary: Devel files needed to build apps based on QuickTemplates2
Group:    Development/Libraries
Requires: %{libqtquicktemplates2} = %version
Provides: libqtquicktemplates5-devel = %version
Provides: qtquicktemplates5-devel = %version

Provides:  %{_lib}qt5quicktemplates-devel = %version-%release
Obsoletes: %{_lib}qt5quicktemplates-devel < 5.13.0-4

%description -n %{libqtquicktemplates2_d}
Devel files needed to build apps based on QuickTemplates2.

%files -n %{libqtquicktemplates2_d}
%{_qt5_archdatadir}/mkspecs/modules/qt_lib_quicktemplates2.pri
%{_qt5_archdatadir}/mkspecs/modules/qt_lib_quicktemplates2_private.pri
%{_qt5_libdir}/libQt5QuickTemplates2.so
%{_qt5_includedir}/QtQuickTemplates2/
%{_qt5_libdir}/libQt5QuickTemplates2.prl
%{_qt5_libdir}/cmake/Qt5QuickTemplates2/
%{_qt5_libdir}/pkgconfig/Qt5QuickTemplates2.pc

#------------------------------------------------------------------------------

%prep
%setup -q -n qtquickcontrols2-everywhere-src-%{qtversion}
%apply_patches

%build
%qmake_qt5

RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"
make -j $RPM_BUILD_NCPUS


%if %{build_docs}
%__make docs
%endif

%install
%make_install INSTALL_ROOT=%{buildroot}

%if %{build_docs}
%make_install install_docs INSTALL_ROOT=%{buildroot}
%endif

find %{buildroot} -name '*.la' -delete


%changelog
* Sun Sep 18 2022 tex - 5.15.6-1pclos2022
- new version
